# Copyright (c) 2024 University of Piraeus Research Centre
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# SPDX-License-Identifier: Apache-2.0
# 
# Contributors:
#     Panagiotis Karamolegkos (UPRC) - Author

apiVersion: apiextensions.k8s.io/v1
kind: CustomResourceDefinition
metadata:
  name: mdm-mons.codeco.com
  namespace: he-codeco-mdm  # The desired namespace for the CRD
spec:
  group: codeco.com
  versions:
    - name: v1
      served: true
      storage: true
      schema:
        openAPIV3Schema:
          type: object
          properties:
            spec:
              type: object
              properties:
                pod_name:
                  description: pod name
                  type: string
                freshness:
                  description: healthiness of the node based on data freshness
                  type: string
                compliance:
                  description: compliance to application requirements
                  type: string
                portability:
                  description: portability level for a specific application
                  type: string
  scope: Namespaced
  names:
    plural: mdm-mons
    singular: mdm-mon
    kind: MDM
    shortNames:
      - mdm-m
